function [Fit_and_p,FVr_bestmemit, fitMaxVector] = ...
CCSTG_1(ccstgParameters,caseStudyData,otherParameters,low_habitat_limit,up_habitat_limit)
    I_NP = ccstgParameters.I_NP;
    I_D  = numel(up_habitat_limit); %Number of variables or dimension
    ccstgParameters.nVariables = I_D;
    FVr_minbound = low_habitat_limit;
    FVr_maxbound = up_habitat_limit;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    fnc=  otherParameters.fnc;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    num_agents = 9;
    rand('state',otherParameters.iRuns) %Guarantee same initial population    
    range_limit = up_habitat_limit - low_habitat_limit;
    [sum_load,index_hash,num_pro_hash] = grouping(num_agents, up_habitat_limit, low_habitat_limit);
    minPositionsMatrix=repmat(FVr_minbound,I_NP,1);
    maxPositionsMatrix=repmat(FVr_maxbound,I_NP,1);
    ccstgParameters.minPositionsMatrix=minPositionsMatrix;
    ccstgParameters.maxPositionsMatrix=maxPositionsMatrix;    
    num_eval = 0;
    I_NP = 1;
    fitMaxVector = [];
    sol_set = unifrnd(low_habitat_limit,up_habitat_limit,1,I_D); % unifrnd(minPositionsMatrix,maxPositionsMatrix,I_NP,I_D);
    [fit_set, ~]=feval(fnc,sol_set,caseStudyData,otherParameters);
    num_eval = num_eval + 1;
    [fit_best, idx_sol_best ]= min(fit_set);
    sol_best = sol_set(idx_sol_best,:);
    fitMaxVector = [fitMaxVector; fit_best];
    step_length = ccstgParameters.step_length;
    step_length_price = ccstgParameters.step_length_price;
    crossover_prob_quantity = 0.1;
    crossover_prob_price = 0.1;
    while num_eval < ccstgParameters.max_eval - 5
        for idx_sol = 1 : I_NP
            sol_candidate = sol_set(idx_sol,:);
            time_temp = randi(24);
            supply_temp = - sum_load(time_temp);
            if rand() > crossover_prob_quantity
                for ind_agent = 1 : num_agents-1
                    if range_limit((ind_agent-1)*24+time_temp) > 0
                        mutation_temp = randn() * step_length;
                        sol_candidate((ind_agent-1)*24+time_temp) = sol_candidate((ind_agent-1)*24+time_temp) + mutation_temp;
                        if sol_candidate((ind_agent-1)*24+time_temp) > up_habitat_limit((ind_agent-1)*24+time_temp)
                            sol_candidate((ind_agent-1)*24+time_temp) = up_habitat_limit((ind_agent-1)*24+time_temp);
                        end % sol_candidate((ind_agent-1)*24+time_temp) > up_habitat_limit((ind_agent-1)*24+time_temp)
                        if sol_candidate((ind_agent-1)*24+time_temp) < low_habitat_limit((ind_agent-1)*24+time_temp)
                            sol_candidate((ind_agent-1)*24+time_temp) = low_habitat_limit((ind_agent-1)*24+time_temp);
                        end % sol_candidate((ind_agent-1)*24+time_temp) < low_habitat_limit((ind_agent-1)*24+time_temp)
                        if supply_temp - sol_candidate((ind_agent-1)*24+time_temp)> 0 
                            sol_candidate((ind_agent-1)*24+time_temp) = supply_temp;
                        end % if supply_temp - sol_candidate((ind_agent-1)*24+time_temp)> 0 
                        supply_temp = supply_temp - sol_candidate((ind_agent-1)*24+time_temp);
                    end % if range_limit((ind_agent-1)*24+time_temp) > 0
                end % for ind_agent = 1 : num_agents
                sol_candidate((num_agents-1)*24+time_temp) = supply_temp;
                if sol_candidate((num_agents-1)*24+time_temp) < low_habitat_limit((num_agents-1)*24+time_temp)
                    sol_candidate((num_agents-1)*24+time_temp) = low_habitat_limit((num_agents-1)*24+time_temp);
                end % if sol_candidate((num_agents-1)*24+time_temp) < low_habitat_limit((num_agents-1)*24+time_temp)
            else % if rand() <= crossover_prob
                index_hash_temp = index_hash{time_temp};
                num_pro_mut = randi(num_pro_hash(time_temp));
                perm_temp = randperm(num_pro_hash(time_temp));
                supply_temp = - sum_load(time_temp);
                for ind_mut = 1 : num_pro_mut
                    crossover_temp = - sum_load(time_temp) / num_pro_mut;
                    if crossover_temp < low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) )
                        crossover_temp = low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) );
                    end % if crossover_temp < low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) )
                    sol_candidate(index_hash_temp(perm_temp(ind_mut))) = crossover_temp;
                    supply_temp = supply_temp - crossover_temp;
                end % for ind_mut = 1 : num_pro_mut
                ind_mut = num_pro_mut + 1;
                while supply_temp < 0 && ind_mut <= num_pro_hash(time_temp)
                    crossover_temp = supply_temp;
                    if crossover_temp < low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) )
                        crossover_temp = low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) );
                    end % if crossover_temp < low_habitat_limit( index_hash_temp(perm_temp(ind_mut)) )
                    sol_candidate(index_hash_temp(perm_temp(ind_mut))) = crossover_temp;
                    supply_temp = supply_temp - crossover_temp;
                    ind_mut = ind_mut + 1;
                end % while supply_temp < 0            
            end % if rand() > crossover_prob        
            [fit_candidate, ~] = feval(fnc,sol_candidate,caseStudyData,otherParameters);
            num_eval = num_eval + 1;
            if fit_candidate < fit_set(idx_sol)
               fit_set(idx_sol) = fit_candidate;
               sol_set(idx_sol,:) = sol_candidate;
            end % if fit_candidate < fit_temp
            if fit_candidate < fit_best
                fit_best = fit_candidate;
                sol_best = sol_candidate;
            end % if fit_temp < fit_best        
            sol_candidate = sol_set(idx_sol,:);
            if rand() > crossover_prob_price
                mutation_temp = randn() * step_length_price;
                price_temp = -1;
                for ind_agent = 1 : num_agents
                    if range_limit((ind_agent-1)*24+time_temp+216) > 0
                        if price_temp == -1
                            price_temp = sol_candidate((ind_agent-1)*24+time_temp+216) + mutation_temp;
                        end % if price_temp == -1
                        sol_candidate((ind_agent-1)*24+time_temp+216) = price_temp;
                        if sol_candidate((ind_agent-1)*24+time_temp+216) > up_habitat_limit((ind_agent-1)*24+time_temp+216)
                            sol_candidate((ind_agent-1)*24+time_temp+216) = up_habitat_limit((ind_agent-1)*24+time_temp+216);
                        end % sol_candidate((ind_agent-1)*24+time_temp) > up_habitat_limit((ind_agent-1)*24+time_temp)
                        if sol_candidate((ind_agent-1)*24+time_temp+216) < low_habitat_limit((ind_agent-1)*24+time_temp+216)
                            sol_candidate((ind_agent-1)*24+time_temp+216) = low_habitat_limit((ind_agent-1)*24+time_temp+216);
                        end % sol_candidate((ind_agent-1)*24+time_temp) < low_habitat_limit((ind_agent-1)*24+time_temp)
                    end % if range_limit((ind_agent-1)*24+time_temp) > 0
                end % for ind_agent = 1 : num_agents
            else
                for ind_agent = 1 : num_agents
                    if range_limit((ind_agent-1)*24+time_temp+216) > 0
                        sol_candidate((ind_agent-1)*24+time_temp+216) = low_habitat_limit((ind_agent-1)*24+time_temp+216);
                    end % if range_limit((ind_agent-1)*24+time_temp) > 0
                end % for ind_agent = 1 : num_agents
            end % if rand() > crossover_prob_price
            % sol_candidate((num_agents-1)*24+time_temp) = supply_temp;
            [fit_candidate, ~] = feval(fnc,sol_candidate,caseStudyData,otherParameters);
            num_eval = num_eval + 1;
            if fit_candidate < fit_set(idx_sol)
               fit_set(idx_sol) = fit_candidate;
               sol_set(idx_sol,:) = sol_candidate;
            end % if fit_candidate < fit_temp
            if fit_candidate < fit_best
                fit_best = fit_candidate;
                sol_best = sol_candidate;
            end % if fit_temp < fit_best
        end % for idx_sol = 1 : I_NP    

        if mod(num_eval,100) == 1
            fitMaxVector = [fitMaxVector; fit_best];
        end % if mod(num_eval,100) == 0

    %     if mod(num_eval,4000) == 1
    %         step_length = step_length / 2;
    %         step_length_price = step_length_price / 2;
    %     end % if mod(num_eval,4000) == 1
    end % while num_eval < deParameters.max_eval
    fitMaxVector = fitMaxVector';
    FVr_bestmemit = sol_best;
    Fit_and_p=[fit_best 0];
end

function [sum_load,index_hash,num_pro_hash] = grouping(num_agents, up_habitat_limit, low_habitat_limit)
    range_limit = up_habitat_limit - low_habitat_limit;
    load_time = zeros(24,num_agents);
    price_threshold_time = zeros(24,num_agents);
    price_time = zeros(24,num_agents);
    sum_load = zeros(24,1);
    index_hash = cell(24,1);
    num_pro_hash = zeros(24,1);
    for ind_time = 1 : 24
        load_time(ind_time,:) = up_habitat_limit(ind_time:24:216);
        sum_load(ind_time) = sum(load_time(ind_time,:));
        price_threshold_time (ind_time,:) = low_habitat_limit(216+ind_time:24:432);
        price_time(ind_time,:) = up_habitat_limit(216+ind_time:24:432);    
        index_temp = [];
        for ind_agent = 1 : num_agents-1
            if range_limit((ind_agent-1)*24+ind_time) > 0
                index_temp = [index_temp;(ind_agent-1)*24+ind_time];
            end % if range_limit((ind_agent-1)*24+time_temp) > 0
        end % for ind_agent = 1 : num_agents-1
        index_hash{ind_time} = index_temp;
        num_pro_hash(ind_time) = size(index_temp,1);
    end % for ind_time = 1 : 24
end

